/*-----------------------------------------------------------------------------
    : io.c
    :  IO ȸθ ׽ƮѴ.
    : freefrug@falinux.com
   ¥ : 2002-04-04 ~
    :

-------------------------------------------------------------------------------*/

#include <linux/config.h>
#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/version.h>
#include <linux/init.h>
#include <linux/fs.h>
#include <linux/sched.h> 
#include <asm/uaccess.h>
#include <asm/hardware.h>
#include <asm/irq.h>
#include <asm/arch-pxa/pxa-regs.h>
#include <linux/interrupt.h>
#include <linux/wait.h>
#include <linux/ioport.h>

#include <asm/ioctl.h>
#include <asm/unistd.h>

#include "io.h"

/*----------------------------------------------------------------------------*/
int io_usage = 0;


/*-----------------------------------------------------------------------------
    : ø̼ǿ ̽  open Ͽ ȣǴ Լ
    : 
   ȯ : ̸ 0 ȯѴ.
    :
-------------------------------------------------------------------------------*/
int io_open( struct inode *minode, struct file *mfile )
{
    // ̹ ̸ ̶  ǵ.
    if( io_usage != 0 ) return -EBUSY;

    MOD_INC_USE_COUNT;  //    ī ũ
    io_usage = 1;       //  
    
    printk("%s Open\n", IO_SAMPLE_NAME );
    return 0;
}
/*-----------------------------------------------------------------------------
    : ø̼ǿ ̽  close Ͽ ȣǴ Լ
    : 
   ȯ : ̸ 0 ȯѴ.
    :
-------------------------------------------------------------------------------*/
int io_release( struct inode *minode, struct file *mfile)
{
    MOD_DEC_USE_COUNT;  //  Ƚ  Ų.
    io_usage = 0;       //   ǥ

    printk("%s Close\n", IO_SAMPLE_NAME );
    return 0;
}
/*-----------------------------------------------------------------------------
    : read
    : 
   ȯ : 
    : 
-------------------------------------------------------------------------------*/
ssize_t io_read(struct file *inode, char *gdata, size_t length, loff_t *off_what)
{
    int   rtn = -1;
    int   idx = 0;      
    unsigned char *addr;
    unsigned char c;
    
    
    // б ּ
    addr = (unsigned char *)(IO_SAMPLE_BASE + IO_SAMPLE_READ_OFFSET);
    
    // ѹ а      ٸ 
    // ġ ȸο   å Ƿ α׷  ´.
    c = *addr;
    
    // delay
    for (idx=0; idx<200; idx++)
    {
        rtn = -1;
    }
            
    if ( c ==  *addr )
    {
        rtn = 1;
        //  ޸𸮿 .
        put_user( c, gdata );
    }        
    
    return rtn;
}
/*-----------------------------------------------------------------------------
    : write
    : 
   ȯ : 
    : 
-------------------------------------------------------------------------------*/
ssize_t io_write(struct file *inode, const char *gdata, size_t length, loff_t *off_what)
{
    unsigned char *addr;
    unsigned char c;

    // ø޸𸮿 ´.
    get_user( c, gdata );
    
    //  ּ
    addr = (unsigned char *)(IO_SAMPLE_BASE + IO_SAMPLE_WRITE_OFFSET);
    
    // output
    *addr = c;        
    
    return 1;
}
/*-----------------------------------------------------------------------------
    : ioctl Լ
    : 
   ȯ : ̸ 0̻ ȯѴ.
    :
-------------------------------------------------------------------------------*/
int io_ioctl( struct inode *minode, struct file *mfile, unsigned int cmd, unsigned long arg )
{
    switch (cmd)
    {
       case SAMPLE_IO_READ : 	
				//  Ѵ.           
            			return 0;
       
       case SAMPLE_IO_WRITE :
				//  Ѵ.           
				return 0;
    }
    
    return -EINVAL;
}
/*-----------------------------------------------------------------------------
    : io ͷƮ Լ
    : 
   ȯ : 
    :
-------------------------------------------------------------------------------*/
void io_interrupt(int irq, void *dev_id, struct pt_regs *regs)
{
    printk( "Sample IO Interrupt %d\n", irq );
}         
/*-----------------------------------------------------------------------------
  ̹ Ǵ  Լ  Լ  ü  Ѵ.
   ü fs.h  Ǿ ִ.
-------------------------------------------------------------------------------*/
static struct file_operations io_fops =
{
    open    : io_open, 
    release : io_release, 
    read    : io_read,
    write   : io_write,
    ioctl   : io_ioctl,
};
/*-----------------------------------------------------------------------------
    : insmodԼ ؼ ȣǴ Լ
    : 
   ȯ : ̸ 0 ȯѴ.
    :
-------------------------------------------------------------------------------*/
static int __init io_init_module (void)
{
    set_GPIO_IRQ_edge ( IO_SAMPLE_GPIO_IRQ, GPIO_RISING_EDGE );

    // IRQ Ѵ. =============================================
    if( request_irq( IO_SAMPLE_IRQ, io_interrupt, 0, IO_SAMPLE_NAME, NULL ) )
    {
	printk( " unable to get IRQ %d\n", IO_SAMPLE_GPIO_IRQ );
	return -EBUSY;
    }
        
	
    // IO  Ѵ. =========================================
    if( check_region( IO_SAMPLE_BASE, IO_SAMPLE_REGION ) )
    {
	free_irq( IO_SAMPLE_IRQ, NULL );
	printk( " unable to get IO region\n" );
	return -ENODEV;
    }
    request_region( IO_SAMPLE_BASE, IO_SAMPLE_REGION, IO_SAMPLE_NAME );
        
        
    // ġ Ѵ. ============================================
    if( !register_chrdev( IO_SAMPLE_MAJOR, IO_SAMPLE_NAME, &io_fops ) )  
    {
            printk(" register device %s OK \n", IO_SAMPLE_VERSION );
    }        
    else
    {        
            release_region( IO_SAMPLE_BASE, IO_SAMPLE_REGION );
            free_irq( IO_SAMPLE_IRQ, IO_SAMPLE_NAME );
            printk(" unable to get major %d for %s \n", IO_SAMPLE_MAJOR, IO_SAMPLE_NAME );
    }
    
    return 0;
}

/*-----------------------------------------------------------------------------
    : rmmodԼ ؼ ȣǴ Լ
    : 
   ȯ : 
    :
---------------------------------------------------------------------r----------*/
static void io_cleanup_module (void)
{
    free_irq( IO_SAMPLE_IRQ, NULL );
    release_region( IO_SAMPLE_BASE, IO_SAMPLE_REGION );
    unregister_chrdev( IO_SAMPLE_MAJOR, IO_SAMPLE_NAME );

    printk("unregister %s OK\n", IO_SAMPLE_NAME );
}

module_init(io_init_module);
module_exit(io_cleanup_module);

