//------------------------------------------------------------------------------
// ȭϸ   : gpio.c
// Ʈ : GPIO ̽ ̺ 
//      : GPIO ̽ ̺ ҽ̴.
// 
// ۼ   :  ()̴Ƽ  tsheaven@falinux.com
// ۼ   : 2003 06 30 ()
// ۱   : ()̴Ƽ 
//      : 
//		1. ̰ EZ-X5 LED ON/OFF GPIO̽ ̹ ϱ 
//		    α׷ ̴.
//
//		2. EZ-X5 DEBUG LED ̿Ͽ α׷Ͽ.
//
//		3.  GPIO GP2, GP3, GP4, GP5 ̴.
//
//------------------------------------------------------------------------------

//******************************************************************************
//
//  
//
//******************************************************************************
#ifndef __KERNEL__
#  define __KERNEL__
#endif
#ifndef MODULE
#  define MODULE
#endif

#include <linux/config.h>
#include <linux/module.h>
#include <linux/kernel.h>   // printk() 
#include <linux/version.h>
#include <linux/slab.h>     // kmalloc() 
#include <linux/fs.h>       // everything... 
#include <linux/errno.h>    // error codes 
#include <linux/types.h>    // size_t 
#include <linux/proc_fs.h>
#include <linux/fcntl.h>    // O_ACCMODE 
#include <linux/ioport.h>
#include <linux/vmalloc.h>
#include <linux/ioctl.h>
#include <linux/sched.h> 
#include <linux/timer.h>
#include <linux/interrupt.h>
#include <linux/major.h>
#include <linux/delay.h>
#include <linux/string.h>
#include <linux/signal.h>
#include <linux/ioport.h>
#include <linux/mm.h>
#include <linux/init.h>

#include <asm/system.h>     // cli(), *_flags 
#include <asm/irq.h>
#include <asm/io.h>
#include <asm/uaccess.h>
#include <asm/hardware.h>
#include <asm/arch-pxa/pxa-regs.h>

#include "gpio.h"

/* Set of debugging defines */
#define GPIO_DEBUG
#undef  GPIO_DEBUG_NO


DECLARE_WAIT_QUEUE_HEAD(gpio_wait);

static int gpio_outb( int data );
static int gpio_inb ( void     );

// ̽   : [ 1̸  / 0̸ ̻  ]
static int gpio_usage      = 0;

//******************************************************************************
//
// Լ 
//
//******************************************************************************

//------------------------------------------------------------------------
//   : IO  ʱȭ Ѵ. 
//   : 
//  ȯ : 
//   : 
//		1. include/asm/arch-pxa/pxa-regs.h   Ǿ  
//
//  		2.        Ʈ ¸ 
//		   http://www.falinux.com  [ ϵ >> XScale [PXA250] GPIO ]
//
//------------------------------------------------------------------------
void GPIO_IO_Init( void ) 
{
	//   
	GAFR0_L &= ~( GPIO_OUTPUT_MASK );	// Disable Alternative Function 
	GRER0   &= ~( GPIO_OUTPUT_MASK );	// Clear Rising edge trigger.
	GFER0   &= ~( GPIO_OUTPUT_MASK );	// Set as Falling Edge Detect
}
//------------------------------------------------------------------------
//   : GPIO 
//   : 
//  ȯ : 
//   : 
//   :
//------------------------------------------------------------------------
int gpio_outb( int data )
{
	//   
	GPDR0 |= ( GPIO_OUTPUT_MASK );

	//GPSR  SET  
	GPSR0 |= ( GPIO_OUTPUT_MASK );	

	//GPCR  Clesar  
	GPCR0  = GPCR0 | (data << 2);

	return 0;
}
//------------------------------------------------------------------------
//   : GPIO Է ó [ü GPIO Է ¸ ] 
//   : 
//  ȯ : 
//   : 
//   :
//------------------------------------------------------------------------
int gpio_inb( void )
{
	// Է  
	GPDR0 &= ~( GPIO_INPUT_MASK );

	return  ~( GPLR0 >> 2 );
}
//------------------------------------------------------------------------
//   : read
//   : 
//  ȯ : 
//   : 
//------------------------------------------------------------------------
ssize_t gpio_read (struct file *filp, char *buf, size_t count, loff_t *f_pos)
{
	unsigned long data=0;

	// GPIO  ° о ´.
	data = ( unsigned long )gpio_inb();
	
	put_user( data, buf );
	
  	return count;
}
//------------------------------------------------------------------------
//   : write
//   : 
//  ȯ : 
//   : 
//   :
//------------------------------------------------------------------------
ssize_t gpio_write(struct file *filp, const char *buf, size_t count, loff_t *f_pos )
{
	const unsigned char *gpiodata = buf;
	int data=0;

	get_user( data, gpiodata );

	gpio_outb( data );

	//  ̸ŭ  ش.
	return count;
}
//------------------------------------------------------------------------
//   : open
//   : 
//  ȯ : 
//   : 
//------------------------------------------------------------------------
int gpio_open(struct inode *inode, struct file *filp)
{
	// ̹ ̸ ̶  ǵ.
	if( gpio_usage != 0 ) return -EBUSY;
  	
	MOD_INC_USE_COUNT;  //  īƮ  Ų.

	gpio_usage = 1;    // ̽ .

	return 0;           
}
//------------------------------------------------------------------------
//   : release
//   : 
//  ȯ : 
//   : 
//------------------------------------------------------------------------
int gpio_release(struct inode *inode, struct file *filp)
{
	MOD_DEC_USE_COUNT;          //  īƮ  Ų.

	gpio_usage = 0;             //   ǥ
	
	return 0;
}
//------------------------------------------------------------------------
//   : file_operations ü
//   : 
//  ȯ : 
//   : 
//------------------------------------------------------------------------
static struct file_operations gpio_fops = 
{
	read	:	gpio_read,
	write	:	gpio_write,
	open	:	gpio_open,
	release	:	gpio_release,
};
//------------------------------------------------------------------------
//   :   
//   : 
//  ȯ : 
//   : 
//   :  
//      	include/asm/arch/irqs.h  GPIO  ǰ ..
//
// 		register_chrdev(   ġ  ȣ, 
//				   ġ , 
//				   ġ  Լ ü ּ  );
//------------------------------------------------------------------------
static int __init gpio_init_module (void)
{
	int result;
    
	// ġ Ѵ.
	result = register_chrdev( GPIO_MAJOR, DEVICE_NAME, &gpio_fops );
	if (result < 0) 
	{
		printk(KERN_WARNING "\n%s : Can't get Major Number [%d]\n", DEVICE_NAME, GPIO_MAJOR);
		return result;
	}
	printk("\n\n\nInit madule, Succeed. This Device is %s and Major Number is [%d]\n\n", DEVICE_NAME, GPIO_MAJOR);

	// GPIO   GPIO ʱȭ
	GPIO_IO_Init();

	return 0; /*  */
}
//------------------------------------------------------------------------
//   :  Ҹ
//   : 
//  ȯ : 
//   : 
//   :
//		unregister_chrdev(  ġ  ȣ,
//                                  ġ   );
//
//------------------------------------------------------------------------
static void gpio_cleanup_module (void)
{
	//  Ѵ..
	if ( !unregister_chrdev( GPIO_MAJOR, DEVICE_NAME) ) 
		printk("%s Device Exit Sucess...\n", DEVICE_NAME);
	else		
		printk("%s Device Exit Fail...\n", DEVICE_NAME);
}

module_init(gpio_init_module);
module_exit(gpio_cleanup_module);
